
varying vec2 v_texcoord;
varying float shadow;

uniform sampler2D frontTexture;
uniform sampler2D backTexture;
uniform float frontAntialiasing;

void main()
{
	vec2 p = v_texcoord;

	// antialias the edges on the front side
	float edgeDist = min(min(p.x, 1.0 - p.x), min(p.y, 1.0 - p.y));
	float alpha = gl_FrontFacing ? clamp(frontAntialiasing * edgeDist, 0.0, 1.0) : 1.0;

	vec4 s = vec4(shadow, shadow, shadow, 1.0);
	vec4 c = s * (gl_FrontFacing ? texture2D(frontTexture, p) : texture2D(backTexture, p));
	
	gl_FragColor = c * alpha;
}
